#include "connection.h"
Connection::Connection(char *host, char *db, char *uid, char *pw) {
#ifdef USE_OLD_FUNCTIONS
  int state;
  connection = mysql_connect(&mysql, host, uid, pw);
  if( !connection ) {
    throw mysql_error(&mysql);
  }
  state = mysql_select_db(connection, db);
  if( state < 0 ) {
    Close();
    throw mysql_error(connection);
  }
#else
  mysql_init(&mysql);
  connection = mysql_real_connect(&mysql, host, uid, pw, db, 0, NULL,0);
  if( !connection ) {
    throw mysql_error(&mysql);
  }
#endif

}

Connection::~Connection() {
    if( connection ) {
	Close();
    }
}

void Connection::Close() {
    if( !connection ) {
	return;
    }
    mysql_close(connection);
    connection = (MYSQL *)NULL;
}

Result *Connection::Query(char *sql) {
    int state;
    
    if( !connection ) {
	throw "Not connected.";
    }
    state = mysql_query(connection, sql);
    if( state < 0 ) {
	throw mysql_error(connection);
    }
    return new Result(mysql_store_result(connection));
}
