#include <stdio.h>
#include <mysql.h>
#include <string.h>
#include "connection.h"
#include "result.h"
#include "row.h"

char sqlserver[]="pc4466.psi.ch";
char sqluser[]="readonly";
char sqlpasswd[]="readonly";

int permute_str(char *result,const char *a, const char *b, const char *c);

int main(int argc,char **argv){
  if(argc!=2){
    printf("usage: %s newtablename\n",argv[0]);
    exit(1);
  }
  
  char newtablename[80];
  char oldtablename[80]="example";
  strcpy(newtablename,argv[1]);
  Connection *connection;
  Result *result;
  Row *row;
  char    sqlquery[512];
  
  //----------------------------------------
  //Connect to server
  //----------------------------------------
  printf("Connectiong...\n");
  connection = new Connection(sqlserver,"test",sqluser,sqlpasswd);            


  //----------------------------------------
  //Copy table structure
  //----------------------------------------
  sprintf(sqlquery,"SHOW CREATE TABLE `%s`;",oldtablename);
  result = connection->Query(sqlquery);
  result->Next();
  row = result->GetCurrentRow();
  permute_str(sqlquery, row->GetField(2),oldtablename, newtablename);
  connection->Query(sqlquery);


  //----------------------------------------
  //Copy data
  //----------------------------------------
  sprintf(sqlquery,"INSERT INTO `%s` SELECT * from `%s`;",newtablename,oldtablename);
  connection->Query(sqlquery);


  //----------------------------------------
  //Disconnect from server
  //---------------------------------------- 
  result->Close();
  delete result;
  connection->Close();
  delete connection;
  printf("Done.\n");
  return 0;
}

int permute_str(char *result,const char *a, const char *b, const char *c)
{
  int  i=0, max_a, max_b;
  result[0] = '\0';
  max_a = strlen(a);
  max_b = strlen(b);
  
  for( i = 0; i <= max_a; i++ ){
    if( 0==strncmp(&a[i], b, max_b) ){
      strcat(result,c);
      i += max_b-1;
    }
    else{
      strncat(result,&a[i],1);
    }
  }
  return 0;
}

