#include <stdio.h>
#include <mysql.h>
#include "connection.h"
#include "result.h"
#include "row.h"

using namespace std;

char sqlserver[]="pc4466.psi.ch";
char sqluser[]="readonly";
char sqlpasswd[]="readonly";

int main(int argc,char **argv){
  if(argc!=2){
    printf("usage: %s runnumber[7107]\n",argv[0]);
    exit(1);
  }

  Connection *connection;
  Result *result;
  Row *row;
  int     run=atoi(argv[1]);
  int     pedrun,ledrun;
  float   pedestal[228];
  float   gain[228];
  char    sqlquery[128];
  int     i;
  
  //----------------------------------------
  //Connect to server
  //----------------------------------------
  printf("Connectiong...\n");
  connection = new Connection(sqlserver,"test",sqluser,sqlpasswd);        
  

  //----------------------------------------
  //Get pedestal/LED run number
  //----------------------------------------
  sprintf(sqlquery,"SELECT ped_id ,gain_id FROM run WHERE id = %d;",run);
  result = connection->Query(sqlquery);    
  //check whether there is a record for this run.
  if(result->GetRowCount()==0){
    printf("There is no data for run %d\n",run);
    result->Close();
    delete result;
    connection->Close();
    delete connection;    
    exit(1);
  }  
  result->Next();
  row = result->GetCurrentRow();
  //get run number of pedestal and led.
  pedrun=atoi(row->GetField(1));
  ledrun=atoi(row->GetField(2));  
  printf("getting pedestal/gain data from run %d and %d\n",pedrun,ledrun);
  

  //----------------------------------------
  //get pedestal and gain from database
  //----------------------------------------
  for(i=0;i<228;i++){
    //pedestal
    sprintf(sqlquery
	    ,"SELECT ped%d FROM adc0_pedestal WHERE id = %d;"
	    ,i,pedrun);
    result = connection->Query(sqlquery);
    result->Next();
    Row *row = result->GetCurrentRow();
    pedestal[i] = atof(row->GetField(1));
    //gain
    sprintf(sqlquery,"SELECT gain%d FROM gain WHERE id = %d;"
	    ,i,ledrun);
    result = connection->Query(sqlquery);
    result->Next();
    row = result->GetCurrentRow();
    gain[i]=atof(row->GetField(1));
  }
  

  //----------------------------------------
  //display
  //---------------------------------------- 
  printf("\tpedestal\tgain\n");
  for(i=0;i<228;i++){
    printf("%3d\t%3.1f\t%3.1e\n",i,pedestal[i],gain[i]);
  }


  //----------------------------------------
  //disconnect from server
  //---------------------------------------- 
  result->Close();
  delete result;
  connection->Close();
  delete connection;
  printf("Done.\n");
  return 0;
}


